<template>
  <div class="formula-block">
    <div class="formula-block__element" v-for="item in items" :key="item.id">
      <div
        v-if="item.tipBelow"
        class="formula-block__element__bottom-tip"
        :class="[item.isBold === true ? 'bold-tip' : '']"
      >
        <span :class="[item.isBold === true ? 'formula-block__element__bold' : '']">{{item.value}}</span>
        <span v-if="item.currency">{{item.currency}}</span>
        <span
          class="formula-block__element__bottom-tip__body"
          :class="[item.tipPositionClass, item.tipSizeClass, item.isBold === true ? 'bold-tip' : '']"
        >{{item.tipBelow}}</span>
      </div>
      <div
        v-else-if="item.tipAbove"
        class="formula-block__element__top-tip"
        :class="[item.isBold === true ? 'bold-tip' : '']"
      >
        <span
          :class="[item.isBold === true ? 'formula-block__element__bold' : '', item.valueSize]"
        >{{item.value}}</span>
        <span v-if="item.currency">{{item.currency}}</span>
        <span
          class="formula-block__element__top-tip__body"
          :class="[item.tipPositionClass, item.tipSizeClass, item.isBold === true ? 'bold-tip' : '']"
        >{{item.tipAbove}}</span>
      </div>
      <div v-else :class="[item.isOperator === true ? 'formula-block__element__symbol' : '']">
        <span>{{item.value}}</span>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: 'FormulaView',

  props: {
    items: {
      type: Array,
      default: () => [],
    },
    value: {
      type: String,
      default: '',
    },
    index: {
      type: String,
      default: '',
    },
    tipAbove: {
      type: String,
      default: '',
    },
    tipBelow: {
      type: String,
      default: '',
    },
    tipPositionClass: {
      type: String,
      default: 'align-center',
    },
    tipSizeClass: {
      type: String,
      default: 'normal',
    },
    isOperator: {
      type: Boolean,
      default: false,
    },
    isBold: {
      type: Boolean,
      default: false,
    },
  },
};
</script>

<style lang="scss" scoped>
$cobalt-black: #191e32;
$shale-gray: #474b5b;
$gray-slate: #737682;

@import '~common-components/src/static/css/mixins';

.formula-block {
  display: flex;
  justify-content: center;
  align-items: center;
  padding: 74px 0;
  margin: 0 auto;
  &__element {
    @include font-mixin(16px, 28px, 400, $gray-slate, 0.4px);
    .currency {
      color: $gray-slate;
    }
    &__bottom-tip {
      position: relative;
      height: 100%;
      &:after {
        content: '';
        position: absolute;
        width: 1px;
        height: 12px;
        background: #9da0ac;
        left: 50%;
        bottom: -15px;
      }
      &__body {
        top: 50px;
        &.narrow {
          min-width: 100px;
          &.align-left {
            left: 25px;
            text-align: left;
          }
          &.align-right {
            left: -40px;
            text-align: right;
          }
          &.align-center {
            left: 0;
            text-align: left;
          }
        }
        &.wide {
          min-width: 275px;
          &.align-right {
            left: -200px;
            text-align: right;
          }
          &.align-left {
            left: 50px;
            text-align: left;
          }
        }
      }
    }
    &__top-tip {
      position: relative;
      height: 100%;
      &:after {
        content: '';
        position: absolute;
        width: 1px;
        height: 12px;
        background: #9da0ac;
        left: 50%;
        top: -15px;
      }
      &.bold-tip {
        &:after {
          background: $cobalt-black;
        }
      }
      &__body {
        bottom: 50px;
        &.narrow {
          &.align-left {
            left: 40px;
            text-align: left;
            min-width: 120px;
          }
          &.align-right {
            left: -40px;
            text-align: right;
            min-width: 100px;
          }
          &.align-center {
            left: 20px;
            text-align: left;
            min-width: 100px;
          }
        }
        &.wide {
          &.align-right {
            left: -200px;
            text-align: right;
            min-width: 275px;
          }
          &.align-left {
            left: 50px;
            text-align: left;
            min-width: 275px;
          }
        }
      }
      .bold-tip {
        color: $cobalt-black;
      }
    }
    &__top-tip__body,
    &__bottom-tip__body {
      @include font-mixin(8px, 12px, 400, $gray-slate, 0.4px);
      position: absolute;
      left: 100%;
      transform: translateX(-20%);
      min-width: 155px;
      text-transform: uppercase;
      word-break: break-word;
    }
    &__symbol {
      margin: 0 5px;
    }
    &__bold {
      font-weight: bold;
      color: $cobalt-black;
    }
    .big {
      font-size: 26px;
    }
  }
}
</style>